/* DLNAPage.c generated by valac 0.52.4, the Vala compiler
 * generated from DLNAPage.vala, do not modify */

/*
 * Copyright (c) 2016 elementary LLC (https://launchpad.net/switchboard-plug-sharing)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "sharing.h"
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gio/gio.h>

enum  {
	SHARING_WIDGETS_DLNA_PAGE_0_PROPERTY,
	SHARING_WIDGETS_DLNA_PAGE_NUM_PROPERTIES
};
static GParamSpec* sharing_widgets_dlna_page_properties[SHARING_WIDGETS_DLNA_PAGE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _SharingWidgetsDLNAPagePrivate {
	SharingBackendRygelStartupManager* rygel_startup_manager;
	SharingBackendRygelConfigFile* rygel_config_file;
	gint content_grid_rows;
};

struct _Block1Data {
	int _ref_count_;
	SharingWidgetsDLNAPage* self;
	GtkFileChooserButton* entry_file_chooser;
	gchar* media_type_id;
};

static gint SharingWidgetsDLNAPage_private_offset;
static gpointer sharing_widgets_dlna_page_parent_class = NULL;

static void __lambda6_ (SharingWidgetsDLNAPage* self,
                 gboolean state);
static void ___lambda6__sharing_widgets_settings_page_switch_state_changed (SharingWidgetsSettingsPage* _sender,
                                                                     gboolean state,
                                                                     gpointer self);
static void sharing_widgets_dlna_page_set_service_state (SharingWidgetsDLNAPage* self);
static gchar* sharing_widgets_dlna_page_replace_xdg_folders (const gchar* folder_path);
static void sharing_widgets_dlna_page_add_media_entry (SharingWidgetsDLNAPage* self,
                                                const gchar* media_type_id,
                                                const gchar* media_type_name);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda7_ (Block1Data* _data1_);
static void ___lambda7__gtk_file_chooser_button_file_set (GtkFileChooserButton* _sender,
                                                   gpointer self);
static gboolean __lambda8_ (Block1Data* _data1_,
                     gboolean state);
static gboolean ___lambda8__gtk_switch_state_set (GtkSwitch* _sender,
                                           gboolean state,
                                           gpointer self);
static GObject * sharing_widgets_dlna_page_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static void sharing_widgets_dlna_page_finalize (GObject * obj);
static GType sharing_widgets_dlna_page_get_type_once (void);

static inline gpointer
sharing_widgets_dlna_page_get_instance_private (SharingWidgetsDLNAPage* self)
{
	return G_STRUCT_MEMBER_P (self, SharingWidgetsDLNAPage_private_offset);
}

static void
__lambda6_ (SharingWidgetsDLNAPage* self,
            gboolean state)
{
	SharingBackendRygelConfigFile* _tmp0_;
	_tmp0_ = self->priv->rygel_config_file;
	if (sharing_backend_rygel_config_file_save (_tmp0_)) {
		SharingBackendRygelStartupManager* _tmp1_;
		SharingWidgetsSettingsPageServiceState _tmp2_ = 0;
		_tmp1_ = self->priv->rygel_startup_manager;
		sharing_backend_rygel_startup_manager_set_service_enabled (_tmp1_, state, NULL, NULL);
		if (state) {
			_tmp2_ = SHARING_WIDGETS_SETTINGS_PAGE_SERVICE_STATE_ENABLED;
		} else {
			_tmp2_ = SHARING_WIDGETS_SETTINGS_PAGE_SERVICE_STATE_DISABLED;
		}
		sharing_widgets_settings_page_update_state ((SharingWidgetsSettingsPage*) self, _tmp2_);
	}
}

static void
___lambda6__sharing_widgets_settings_page_switch_state_changed (SharingWidgetsSettingsPage* _sender,
                                                                gboolean state,
                                                                gpointer self)
{
	__lambda6_ ((SharingWidgetsDLNAPage*) self, state);
}

SharingWidgetsDLNAPage*
sharing_widgets_dlna_page_construct (GType object_type)
{
	SharingWidgetsDLNAPage * self = NULL;
	self = (SharingWidgetsDLNAPage*) sharing_widgets_settings_page_construct (object_type, "dlna", _ ("Media Library"), "applications-multimedia", _ ("While enabled, the following media libraries are shared to compatible " \
"devices in your network."), _ ("While disabled, the selected media libraries are unshared, and it won'" \
"t stream files from your computer to other devices."));
	g_signal_connect_object ((SharingWidgetsSettingsPage*) self, "switch-state-changed", (GCallback) ___lambda6__sharing_widgets_settings_page_switch_state_changed, self, 0);
	sharing_widgets_dlna_page_set_service_state (self);
	return self;
}

SharingWidgetsDLNAPage*
sharing_widgets_dlna_page_new (void)
{
	return sharing_widgets_dlna_page_construct (SHARING_WIDGETS_TYPE_DLNA_PAGE);
}

static gchar*
sharing_widgets_dlna_page_replace_xdg_folders (const gchar* folder_path)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	static GQuark _tmp1_label2 = 0;
	gchar* result = NULL;
	g_return_val_if_fail (folder_path != NULL, NULL);
	_tmp0_ = folder_path;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("@MUSIC@")))) {
		switch (0) {
			default:
			{
				const gchar* _tmp3_;
				gchar* _tmp4_;
				_tmp3_ = g_get_user_special_dir (G_USER_DIRECTORY_MUSIC);
				_tmp4_ = g_strdup (_tmp3_);
				result = _tmp4_;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("@VIDEOS@")))) {
		switch (0) {
			default:
			{
				const gchar* _tmp5_;
				gchar* _tmp6_;
				_tmp5_ = g_get_user_special_dir (G_USER_DIRECTORY_VIDEOS);
				_tmp6_ = g_strdup (_tmp5_);
				result = _tmp6_;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("@PICTURES@")))) {
		switch (0) {
			default:
			{
				const gchar* _tmp7_;
				gchar* _tmp8_;
				_tmp7_ = g_get_user_special_dir (G_USER_DIRECTORY_PICTURES);
				_tmp8_ = g_strdup (_tmp7_);
				result = _tmp8_;
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				gchar* _tmp9_;
				_tmp9_ = g_strdup (folder_path);
				result = _tmp9_;
				return result;
			}
		}
	}
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		SharingWidgetsDLNAPage* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->entry_file_chooser);
		_g_free0 (_data1_->media_type_id);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static void
__lambda7_ (Block1Data* _data1_)
{
	SharingWidgetsDLNAPage* self;
	SharingBackendRygelConfigFile* _tmp0_;
	GtkFileChooserButton* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	SharingBackendRygelConfigFile* _tmp6_;
	self = _data1_->self;
	_tmp0_ = self->priv->rygel_config_file;
	_tmp1_ = _data1_->entry_file_chooser;
	_tmp2_ = gtk_file_chooser_get_file ((GtkFileChooser*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_file_get_path (_tmp3_);
	_tmp5_ = _tmp4_;
	sharing_backend_rygel_config_file_set_media_type_folder (_tmp0_, _data1_->media_type_id, _tmp5_);
	_g_free0 (_tmp5_);
	_g_object_unref0 (_tmp3_);
	_tmp6_ = self->priv->rygel_config_file;
	sharing_backend_rygel_config_file_save (_tmp6_);
}

static void
___lambda7__gtk_file_chooser_button_file_set (GtkFileChooserButton* _sender,
                                              gpointer self)
{
	__lambda7_ (self);
}

static gboolean
__lambda8_ (Block1Data* _data1_,
            gboolean state)
{
	SharingWidgetsDLNAPage* self;
	GtkFileChooserButton* _tmp0_;
	SharingBackendRygelConfigFile* _tmp1_;
	SharingBackendRygelConfigFile* _tmp2_;
	gboolean result = FALSE;
	self = _data1_->self;
	_tmp0_ = _data1_->entry_file_chooser;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, state);
	_tmp1_ = self->priv->rygel_config_file;
	sharing_backend_rygel_config_file_set_media_type_enabled (_tmp1_, _data1_->media_type_id, state);
	_tmp2_ = self->priv->rygel_config_file;
	sharing_backend_rygel_config_file_save (_tmp2_);
	result = FALSE;
	return result;
}

static gboolean
___lambda8__gtk_switch_state_set (GtkSwitch* _sender,
                                  gboolean state,
                                  gpointer self)
{
	gboolean result;
	result = __lambda8_ (self, state);
	return result;
}

static void
sharing_widgets_dlna_page_add_media_entry (SharingWidgetsDLNAPage* self,
                                           const gchar* media_type_id,
                                           const gchar* media_type_name)
{
	Block1Data* _data1_;
	gchar* _tmp0_;
	gboolean is_enabled = FALSE;
	SharingBackendRygelConfigFile* _tmp1_;
	gchar* folder_path = NULL;
	SharingBackendRygelConfigFile* _tmp2_;
	gchar* _tmp3_;
	GtkLabel* entry_label = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GtkFileChooserButton* _tmp11_;
	GtkFileChooserButton* _tmp12_;
	GtkFileChooserButton* _tmp13_;
	GtkFileChooserButton* _tmp14_;
	GtkFileChooserButton* _tmp15_;
	GtkSwitch* entry_switch = NULL;
	GtkSwitch* _tmp26_;
	GtkGrid* _tmp27_;
	GtkLabel* _tmp28_;
	GtkGrid* _tmp29_;
	GtkFileChooserButton* _tmp30_;
	GtkGrid* _tmp31_;
	gint _tmp32_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (media_type_id != NULL);
	g_return_if_fail (media_type_name != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = g_strdup (media_type_id);
	_g_free0 (_data1_->media_type_id);
	_data1_->media_type_id = _tmp0_;
	_tmp1_ = self->priv->rygel_config_file;
	is_enabled = sharing_backend_rygel_config_file_get_media_type_enabled (_tmp1_, _data1_->media_type_id);
	_tmp2_ = self->priv->rygel_config_file;
	_tmp3_ = sharing_backend_rygel_config_file_get_media_type_folder (_tmp2_, _data1_->media_type_id);
	folder_path = _tmp3_;
	_tmp4_ = g_strdup_printf ("%s:", media_type_name);
	_tmp5_ = _tmp4_;
	_tmp6_ = (GtkLabel*) gtk_label_new (_tmp5_);
	g_object_ref_sink (_tmp6_);
	_tmp7_ = _tmp6_;
	_g_free0 (_tmp5_);
	entry_label = _tmp7_;
	_tmp8_ = entry_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp8_, GTK_ALIGN_END);
	_tmp9_ = g_strdup_printf (_ ("Select the folder containing your %s"), media_type_name);
	_tmp10_ = _tmp9_;
	_tmp11_ = (GtkFileChooserButton*) gtk_file_chooser_button_new (_tmp10_, GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER);
	g_object_ref_sink (_tmp11_);
	_tmp12_ = _tmp11_;
	_g_free0 (_tmp10_);
	_data1_->entry_file_chooser = _tmp12_;
	_tmp13_ = _data1_->entry_file_chooser;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp13_, TRUE);
	_tmp14_ = _data1_->entry_file_chooser;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, is_enabled);
	_tmp15_ = _data1_->entry_file_chooser;
	g_signal_connect_data (_tmp15_, "file-set", (GCallback) ___lambda7__gtk_file_chooser_button_file_set, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	{
		const gchar* _tmp16_;
		_tmp16_ = folder_path;
		if (g_strcmp0 (_tmp16_, "") != 0) {
			GtkFileChooserButton* _tmp17_;
			const gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			GFile* _tmp21_;
			GFile* _tmp22_;
			_tmp17_ = _data1_->entry_file_chooser;
			_tmp18_ = folder_path;
			_tmp19_ = sharing_widgets_dlna_page_replace_xdg_folders (_tmp18_);
			_tmp20_ = _tmp19_;
			_tmp21_ = g_file_new_for_path (_tmp20_);
			_tmp22_ = _tmp21_;
			gtk_file_chooser_set_file ((GtkFileChooser*) _tmp17_, _tmp22_, &_inner_error0_);
			_g_object_unref0 (_tmp22_);
			_g_free0 (_tmp20_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp23_;
		GError* _tmp24_;
		const gchar* _tmp25_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp23_ = folder_path;
		_tmp24_ = e;
		_tmp25_ = _tmp24_->message;
		g_warning ("DLNAPage.vala:82: The folder path %s is invalid: %s", _tmp23_, _tmp25_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (entry_label);
		_g_free0 (folder_path);
		block1_data_unref (_data1_);
		_data1_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp26_ = (GtkSwitch*) gtk_switch_new ();
	g_object_ref_sink (_tmp26_);
	entry_switch = _tmp26_;
	gtk_widget_set_valign ((GtkWidget*) entry_switch, GTK_ALIGN_CENTER);
	gtk_switch_set_state (entry_switch, is_enabled);
	g_signal_connect_data (entry_switch, "state-set", (GCallback) ___lambda8__gtk_switch_state_set, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp27_ = ((SharingWidgetsSettingsPage*) self)->content_grid;
	_tmp28_ = entry_label;
	gtk_grid_attach (_tmp27_, (GtkWidget*) _tmp28_, 0, self->priv->content_grid_rows, 1, 1);
	_tmp29_ = ((SharingWidgetsSettingsPage*) self)->content_grid;
	_tmp30_ = _data1_->entry_file_chooser;
	gtk_grid_attach (_tmp29_, (GtkWidget*) _tmp30_, 1, self->priv->content_grid_rows, 1, 1);
	_tmp31_ = ((SharingWidgetsSettingsPage*) self)->content_grid;
	gtk_grid_attach (_tmp31_, (GtkWidget*) entry_switch, 2, self->priv->content_grid_rows, 1, 1);
	_tmp32_ = self->priv->content_grid_rows;
	self->priv->content_grid_rows = _tmp32_ + 1;
	_g_object_unref0 (entry_switch);
	_g_object_unref0 (entry_label);
	_g_free0 (folder_path);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}

static void
sharing_widgets_dlna_page_set_service_state (SharingWidgetsDLNAPage* self)
{
	SharingWidgetsSettingsPageServiceState _tmp0_ = 0;
	SharingBackendRygelStartupManager* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->rygel_startup_manager;
	if (sharing_backend_rygel_startup_manager_get_service_enabled (_tmp1_)) {
		_tmp0_ = SHARING_WIDGETS_SETTINGS_PAGE_SERVICE_STATE_ENABLED;
	} else {
		_tmp0_ = SHARING_WIDGETS_SETTINGS_PAGE_SERVICE_STATE_DISABLED;
	}
	sharing_widgets_settings_page_update_state ((SharingWidgetsSettingsPage*) self, _tmp0_);
}

static GObject *
sharing_widgets_dlna_page_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SharingWidgetsDLNAPage * self;
	SharingBackendRygelStartupManager* _tmp0_;
	SharingBackendRygelConfigFile* _tmp1_;
	parent_class = G_OBJECT_CLASS (sharing_widgets_dlna_page_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SHARING_WIDGETS_TYPE_DLNA_PAGE, SharingWidgetsDLNAPage);
	_tmp0_ = sharing_backend_rygel_startup_manager_new ();
	_g_object_unref0 (self->priv->rygel_startup_manager);
	self->priv->rygel_startup_manager = _tmp0_;
	_tmp1_ = sharing_backend_rygel_config_file_new ();
	_g_object_unref0 (self->priv->rygel_config_file);
	self->priv->rygel_config_file = _tmp1_;
	sharing_widgets_dlna_page_add_media_entry (self, "music", _ ("Music"));
	sharing_widgets_dlna_page_add_media_entry (self, "videos", _ ("Videos"));
	sharing_widgets_dlna_page_add_media_entry (self, "pictures", _ ("Photos"));
	return obj;
}

static void
sharing_widgets_dlna_page_class_init (SharingWidgetsDLNAPageClass * klass,
                                      gpointer klass_data)
{
	sharing_widgets_dlna_page_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SharingWidgetsDLNAPage_private_offset);
	G_OBJECT_CLASS (klass)->constructor = sharing_widgets_dlna_page_constructor;
	G_OBJECT_CLASS (klass)->finalize = sharing_widgets_dlna_page_finalize;
}

static void
sharing_widgets_dlna_page_instance_init (SharingWidgetsDLNAPage * self,
                                         gpointer klass)
{
	self->priv = sharing_widgets_dlna_page_get_instance_private (self);
	self->priv->content_grid_rows = 0;
}

static void
sharing_widgets_dlna_page_finalize (GObject * obj)
{
	SharingWidgetsDLNAPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SHARING_WIDGETS_TYPE_DLNA_PAGE, SharingWidgetsDLNAPage);
	_g_object_unref0 (self->priv->rygel_startup_manager);
	_g_object_unref0 (self->priv->rygel_config_file);
	G_OBJECT_CLASS (sharing_widgets_dlna_page_parent_class)->finalize (obj);
}

static GType
sharing_widgets_dlna_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SharingWidgetsDLNAPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sharing_widgets_dlna_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SharingWidgetsDLNAPage), 0, (GInstanceInitFunc) sharing_widgets_dlna_page_instance_init, NULL };
	GType sharing_widgets_dlna_page_type_id;
	sharing_widgets_dlna_page_type_id = g_type_register_static (SHARING_WIDGETS_TYPE_SETTINGS_PAGE, "SharingWidgetsDLNAPage", &g_define_type_info, 0);
	SharingWidgetsDLNAPage_private_offset = g_type_add_instance_private (sharing_widgets_dlna_page_type_id, sizeof (SharingWidgetsDLNAPagePrivate));
	return sharing_widgets_dlna_page_type_id;
}

GType
sharing_widgets_dlna_page_get_type (void)
{
	static volatile gsize sharing_widgets_dlna_page_type_id__volatile = 0;
	if (g_once_init_enter (&sharing_widgets_dlna_page_type_id__volatile)) {
		GType sharing_widgets_dlna_page_type_id;
		sharing_widgets_dlna_page_type_id = sharing_widgets_dlna_page_get_type_once ();
		g_once_init_leave (&sharing_widgets_dlna_page_type_id__volatile, sharing_widgets_dlna_page_type_id);
	}
	return sharing_widgets_dlna_page_type_id__volatile;
}

