/* ServiceEntry.c generated by valac 0.52.4, the Vala compiler
 * generated from ServiceEntry.vala, do not modify */

/*
 * Copyright (c) 2011-2018 elementary LLC (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "sharing.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <granite.h>
#include <pango/pango.h>

enum  {
	SHARING_WIDGETS_SERVICE_ENTRY_0_PROPERTY,
	SHARING_WIDGETS_SERVICE_ENTRY_ID_PROPERTY,
	SHARING_WIDGETS_SERVICE_ENTRY_TITLE_PROPERTY,
	SHARING_WIDGETS_SERVICE_ENTRY_ICON_NAME_PROPERTY,
	SHARING_WIDGETS_SERVICE_ENTRY_SERVICE_STATE_PROPERTY,
	SHARING_WIDGETS_SERVICE_ENTRY_NUM_PROPERTIES
};
static GParamSpec* sharing_widgets_service_entry_properties[SHARING_WIDGETS_SERVICE_ENTRY_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SharingWidgetsServiceEntryPrivate {
	gchar* _id;
	gchar* _title;
	gchar* _icon_name;
	SharingWidgetsSettingsPageServiceState _service_state;
	GtkGrid* grid;
	GtkOverlay* overlay_icon;
	GtkImage* primary_icon;
	GtkImage* secondary_icon;
	GtkLabel* title_label;
	GtkLabel* subtitle_label;
};

static gint SharingWidgetsServiceEntry_private_offset;
static gpointer sharing_widgets_service_entry_parent_class = NULL;

static gchar* sharing_widgets_service_entry_state_to_string (SharingWidgetsSettingsPageServiceState service_state);
static gchar* sharing_widgets_service_entry_state_to_icon_name (SharingWidgetsSettingsPageServiceState service_state);
static void sharing_widgets_service_entry_build_ui (SharingWidgetsServiceEntry* self);
static void sharing_widgets_service_entry_finalize (GObject * obj);
static GType sharing_widgets_service_entry_get_type_once (void);
static void _vala_sharing_widgets_service_entry_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);
static void _vala_sharing_widgets_service_entry_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec);

static inline gpointer
sharing_widgets_service_entry_get_instance_private (SharingWidgetsServiceEntry* self)
{
	return G_STRUCT_MEMBER_P (self, SharingWidgetsServiceEntry_private_offset);
}

static gchar*
sharing_widgets_service_entry_state_to_string (SharingWidgetsSettingsPageServiceState service_state)
{
	gchar* result = NULL;
	switch (service_state) {
		case SHARING_WIDGETS_SETTINGS_PAGE_SERVICE_STATE_ENABLED:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Enabled"));
			result = _tmp0_;
			return result;
		}
		case SHARING_WIDGETS_SETTINGS_PAGE_SERVICE_STATE_NOT_AVAILABLE:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Not Available"));
			result = _tmp1_;
			return result;
		}
		case SHARING_WIDGETS_SETTINGS_PAGE_SERVICE_STATE_CONNECTED:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Connected"));
			result = _tmp2_;
			return result;
		}
		default:
		case SHARING_WIDGETS_SETTINGS_PAGE_SERVICE_STATE_DISABLED:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Disabled"));
			result = _tmp3_;
			return result;
		}
	}
}

static gchar*
sharing_widgets_service_entry_state_to_icon_name (SharingWidgetsSettingsPageServiceState service_state)
{
	gchar* result = NULL;
	switch (service_state) {
		case SHARING_WIDGETS_SETTINGS_PAGE_SERVICE_STATE_ENABLED:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("user-available");
			result = _tmp0_;
			return result;
		}
		case SHARING_WIDGETS_SETTINGS_PAGE_SERVICE_STATE_NOT_AVAILABLE:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("user-busy");
			result = _tmp1_;
			return result;
		}
		case SHARING_WIDGETS_SETTINGS_PAGE_SERVICE_STATE_CONNECTED:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("mail-unread");
			result = _tmp2_;
			return result;
		}
		default:
		case SHARING_WIDGETS_SETTINGS_PAGE_SERVICE_STATE_DISABLED:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("user-offline");
			result = _tmp3_;
			return result;
		}
	}
}

SharingWidgetsServiceEntry*
sharing_widgets_service_entry_construct (GType object_type,
                                         const gchar* id,
                                         const gchar* title,
                                         const gchar* icon_name,
                                         SharingWidgetsSettingsPageServiceState service_state)
{
	SharingWidgetsServiceEntry * self = NULL;
	g_return_val_if_fail (id != NULL, NULL);
	g_return_val_if_fail (title != NULL, NULL);
	g_return_val_if_fail (icon_name != NULL, NULL);
	self = (SharingWidgetsServiceEntry*) g_object_new (object_type, "id", id, "title", title, "icon-name", icon_name, "service-state", service_state, NULL);
	sharing_widgets_service_entry_build_ui (self);
	return self;
}

SharingWidgetsServiceEntry*
sharing_widgets_service_entry_new (const gchar* id,
                                   const gchar* title,
                                   const gchar* icon_name,
                                   SharingWidgetsSettingsPageServiceState service_state)
{
	return sharing_widgets_service_entry_construct (SHARING_WIDGETS_TYPE_SERVICE_ENTRY, id, title, icon_name, service_state);
}

void
sharing_widgets_service_entry_update_state (SharingWidgetsServiceEntry* self,
                                            SharingWidgetsSettingsPageServiceState state)
{
	GtkImage* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GtkLabel* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->secondary_icon;
	_tmp1_ = sharing_widgets_service_entry_state_to_icon_name (state);
	_tmp2_ = _tmp1_;
	gtk_image_set_from_icon_name (_tmp0_, _tmp2_, (GtkIconSize) GTK_ICON_SIZE_MENU);
	_g_free0 (_tmp2_);
	_tmp3_ = self->priv->subtitle_label;
	_tmp4_ = sharing_widgets_service_entry_state_to_string (state);
	_tmp5_ = _tmp4_;
	gtk_label_set_label (_tmp3_, _tmp5_);
	_g_free0 (_tmp5_);
	sharing_widgets_service_entry_set_service_state (self, state);
}

static void
sharing_widgets_service_entry_build_ui (SharingWidgetsServiceEntry* self)
{
	GtkGrid* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
	GtkOverlay* _tmp3_;
	const gchar* _tmp4_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	SharingWidgetsSettingsPageServiceState _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GtkImage* _tmp10_;
	GtkImage* _tmp11_;
	GtkImage* _tmp12_;
	GtkImage* _tmp13_;
	GtkImage* _tmp14_;
	GtkOverlay* _tmp15_;
	GtkImage* _tmp16_;
	GtkOverlay* _tmp17_;
	GtkImage* _tmp18_;
	const gchar* _tmp19_;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GtkStyleContext* _tmp22_;
	GtkLabel* _tmp23_;
	GtkLabel* _tmp24_;
	SharingWidgetsSettingsPageServiceState _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	GtkLabel* _tmp28_;
	GtkLabel* _tmp29_;
	GtkGrid* _tmp30_;
	GtkOverlay* _tmp31_;
	GtkGrid* _tmp32_;
	GtkLabel* _tmp33_;
	GtkGrid* _tmp34_;
	GtkLabel* _tmp35_;
	GtkGrid* _tmp36_;
	g_return_if_fail (self != NULL);
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->grid);
	self->priv->grid = _tmp0_;
	_tmp1_ = self->priv->grid;
	g_object_set ((GtkWidget*) _tmp1_, "margin", 6, NULL);
	_tmp2_ = self->priv->grid;
	gtk_grid_set_column_spacing (_tmp2_, 3);
	_tmp3_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->overlay_icon);
	self->priv->overlay_icon = _tmp3_;
	_tmp4_ = self->priv->_icon_name;
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp4_, (GtkIconSize) GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->primary_icon);
	self->priv->primary_icon = _tmp5_;
	_tmp6_ = self->priv->primary_icon;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp6_, 3);
	_tmp7_ = self->priv->_service_state;
	_tmp8_ = sharing_widgets_service_entry_state_to_icon_name (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp9_, (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp10_);
	_g_object_unref0 (self->priv->secondary_icon);
	self->priv->secondary_icon = _tmp10_;
	_g_free0 (_tmp9_);
	_tmp11_ = self->priv->secondary_icon;
	gtk_widget_set_halign ((GtkWidget*) _tmp11_, GTK_ALIGN_END);
	_tmp12_ = self->priv->secondary_icon;
	gtk_widget_set_valign ((GtkWidget*) _tmp12_, GTK_ALIGN_END);
	_tmp13_ = self->priv->secondary_icon;
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_misc_get_type (), GtkMisc), "xalign", 0.5f, NULL);
	_tmp14_ = self->priv->secondary_icon;
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_misc_get_type (), GtkMisc), "yalign", 0.5f, NULL);
	_tmp15_ = self->priv->overlay_icon;
	_tmp16_ = self->priv->primary_icon;
	gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
	_tmp17_ = self->priv->overlay_icon;
	_tmp18_ = self->priv->secondary_icon;
	gtk_overlay_add_overlay (_tmp17_, (GtkWidget*) _tmp18_);
	_tmp19_ = self->priv->_title;
	_tmp20_ = (GtkLabel*) gtk_label_new (_tmp19_);
	g_object_ref_sink (_tmp20_);
	_g_object_unref0 (self->priv->title_label);
	self->priv->title_label = _tmp20_;
	_tmp21_ = self->priv->title_label;
	_tmp22_ = gtk_widget_get_style_context ((GtkWidget*) _tmp21_);
	gtk_style_context_add_class (_tmp22_, GRANITE_STYLE_CLASS_H3_LABEL);
	_tmp23_ = self->priv->title_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp23_, GTK_ALIGN_START);
	_tmp24_ = self->priv->title_label;
	gtk_label_set_ellipsize (_tmp24_, PANGO_ELLIPSIZE_END);
	_tmp25_ = self->priv->_service_state;
	_tmp26_ = sharing_widgets_service_entry_state_to_string (_tmp25_);
	_tmp27_ = _tmp26_;
	_tmp28_ = (GtkLabel*) gtk_label_new (_tmp27_);
	g_object_ref_sink (_tmp28_);
	_g_object_unref0 (self->priv->subtitle_label);
	self->priv->subtitle_label = _tmp28_;
	_g_free0 (_tmp27_);
	_tmp29_ = self->priv->subtitle_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp29_, GTK_ALIGN_START);
	_tmp30_ = self->priv->grid;
	_tmp31_ = self->priv->overlay_icon;
	gtk_grid_attach (_tmp30_, (GtkWidget*) _tmp31_, 0, 0, 1, 2);
	_tmp32_ = self->priv->grid;
	_tmp33_ = self->priv->title_label;
	gtk_grid_attach (_tmp32_, (GtkWidget*) _tmp33_, 1, 0, 1, 1);
	_tmp34_ = self->priv->grid;
	_tmp35_ = self->priv->subtitle_label;
	gtk_grid_attach (_tmp34_, (GtkWidget*) _tmp35_, 1, 1, 1, 1);
	_tmp36_ = self->priv->grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp36_);
}

const gchar*
sharing_widgets_service_entry_get_id (SharingWidgetsServiceEntry* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_id;
	result = _tmp0_;
	return result;
}

static void
sharing_widgets_service_entry_set_id (SharingWidgetsServiceEntry* self,
                                      const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = sharing_widgets_service_entry_get_id (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_id);
		self->priv->_id = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, sharing_widgets_service_entry_properties[SHARING_WIDGETS_SERVICE_ENTRY_ID_PROPERTY]);
	}
}

const gchar*
sharing_widgets_service_entry_get_title (SharingWidgetsServiceEntry* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_title;
	result = _tmp0_;
	return result;
}

static void
sharing_widgets_service_entry_set_title (SharingWidgetsServiceEntry* self,
                                         const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = sharing_widgets_service_entry_get_title (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_title);
		self->priv->_title = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, sharing_widgets_service_entry_properties[SHARING_WIDGETS_SERVICE_ENTRY_TITLE_PROPERTY]);
	}
}

const gchar*
sharing_widgets_service_entry_get_icon_name (SharingWidgetsServiceEntry* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_icon_name;
	result = _tmp0_;
	return result;
}

static void
sharing_widgets_service_entry_set_icon_name (SharingWidgetsServiceEntry* self,
                                             const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = sharing_widgets_service_entry_get_icon_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_icon_name);
		self->priv->_icon_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, sharing_widgets_service_entry_properties[SHARING_WIDGETS_SERVICE_ENTRY_ICON_NAME_PROPERTY]);
	}
}

SharingWidgetsSettingsPageServiceState
sharing_widgets_service_entry_get_service_state (SharingWidgetsServiceEntry* self)
{
	SharingWidgetsSettingsPageServiceState result;
	SharingWidgetsSettingsPageServiceState _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_service_state;
	result = _tmp0_;
	return result;
}

void
sharing_widgets_service_entry_set_service_state (SharingWidgetsServiceEntry* self,
                                                 SharingWidgetsSettingsPageServiceState value)
{
	SharingWidgetsSettingsPageServiceState old_value;
	g_return_if_fail (self != NULL);
	old_value = sharing_widgets_service_entry_get_service_state (self);
	if (old_value != value) {
		self->priv->_service_state = value;
		g_object_notify_by_pspec ((GObject *) self, sharing_widgets_service_entry_properties[SHARING_WIDGETS_SERVICE_ENTRY_SERVICE_STATE_PROPERTY]);
	}
}

static void
sharing_widgets_service_entry_class_init (SharingWidgetsServiceEntryClass * klass,
                                          gpointer klass_data)
{
	sharing_widgets_service_entry_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SharingWidgetsServiceEntry_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_sharing_widgets_service_entry_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sharing_widgets_service_entry_set_property;
	G_OBJECT_CLASS (klass)->finalize = sharing_widgets_service_entry_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SHARING_WIDGETS_SERVICE_ENTRY_ID_PROPERTY, sharing_widgets_service_entry_properties[SHARING_WIDGETS_SERVICE_ENTRY_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SHARING_WIDGETS_SERVICE_ENTRY_TITLE_PROPERTY, sharing_widgets_service_entry_properties[SHARING_WIDGETS_SERVICE_ENTRY_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SHARING_WIDGETS_SERVICE_ENTRY_ICON_NAME_PROPERTY, sharing_widgets_service_entry_properties[SHARING_WIDGETS_SERVICE_ENTRY_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SHARING_WIDGETS_SERVICE_ENTRY_SERVICE_STATE_PROPERTY, sharing_widgets_service_entry_properties[SHARING_WIDGETS_SERVICE_ENTRY_SERVICE_STATE_PROPERTY] = g_param_spec_enum ("service-state", "service-state", "service-state", SHARING_WIDGETS_SETTINGS_PAGE_TYPE_SERVICE_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
}

static void
sharing_widgets_service_entry_instance_init (SharingWidgetsServiceEntry * self,
                                             gpointer klass)
{
	self->priv = sharing_widgets_service_entry_get_instance_private (self);
}

static void
sharing_widgets_service_entry_finalize (GObject * obj)
{
	SharingWidgetsServiceEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SHARING_WIDGETS_TYPE_SERVICE_ENTRY, SharingWidgetsServiceEntry);
	_g_free0 (self->priv->_id);
	_g_free0 (self->priv->_title);
	_g_free0 (self->priv->_icon_name);
	_g_object_unref0 (self->priv->grid);
	_g_object_unref0 (self->priv->overlay_icon);
	_g_object_unref0 (self->priv->primary_icon);
	_g_object_unref0 (self->priv->secondary_icon);
	_g_object_unref0 (self->priv->title_label);
	_g_object_unref0 (self->priv->subtitle_label);
	G_OBJECT_CLASS (sharing_widgets_service_entry_parent_class)->finalize (obj);
}

static GType
sharing_widgets_service_entry_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SharingWidgetsServiceEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sharing_widgets_service_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SharingWidgetsServiceEntry), 0, (GInstanceInitFunc) sharing_widgets_service_entry_instance_init, NULL };
	GType sharing_widgets_service_entry_type_id;
	sharing_widgets_service_entry_type_id = g_type_register_static (gtk_list_box_row_get_type (), "SharingWidgetsServiceEntry", &g_define_type_info, 0);
	SharingWidgetsServiceEntry_private_offset = g_type_add_instance_private (sharing_widgets_service_entry_type_id, sizeof (SharingWidgetsServiceEntryPrivate));
	return sharing_widgets_service_entry_type_id;
}

GType
sharing_widgets_service_entry_get_type (void)
{
	static volatile gsize sharing_widgets_service_entry_type_id__volatile = 0;
	if (g_once_init_enter (&sharing_widgets_service_entry_type_id__volatile)) {
		GType sharing_widgets_service_entry_type_id;
		sharing_widgets_service_entry_type_id = sharing_widgets_service_entry_get_type_once ();
		g_once_init_leave (&sharing_widgets_service_entry_type_id__volatile, sharing_widgets_service_entry_type_id);
	}
	return sharing_widgets_service_entry_type_id__volatile;
}

static void
_vala_sharing_widgets_service_entry_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	SharingWidgetsServiceEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SHARING_WIDGETS_TYPE_SERVICE_ENTRY, SharingWidgetsServiceEntry);
	switch (property_id) {
		case SHARING_WIDGETS_SERVICE_ENTRY_ID_PROPERTY:
		g_value_set_string (value, sharing_widgets_service_entry_get_id (self));
		break;
		case SHARING_WIDGETS_SERVICE_ENTRY_TITLE_PROPERTY:
		g_value_set_string (value, sharing_widgets_service_entry_get_title (self));
		break;
		case SHARING_WIDGETS_SERVICE_ENTRY_ICON_NAME_PROPERTY:
		g_value_set_string (value, sharing_widgets_service_entry_get_icon_name (self));
		break;
		case SHARING_WIDGETS_SERVICE_ENTRY_SERVICE_STATE_PROPERTY:
		g_value_set_enum (value, sharing_widgets_service_entry_get_service_state (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_sharing_widgets_service_entry_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec)
{
	SharingWidgetsServiceEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SHARING_WIDGETS_TYPE_SERVICE_ENTRY, SharingWidgetsServiceEntry);
	switch (property_id) {
		case SHARING_WIDGETS_SERVICE_ENTRY_ID_PROPERTY:
		sharing_widgets_service_entry_set_id (self, g_value_get_string (value));
		break;
		case SHARING_WIDGETS_SERVICE_ENTRY_TITLE_PROPERTY:
		sharing_widgets_service_entry_set_title (self, g_value_get_string (value));
		break;
		case SHARING_WIDGETS_SERVICE_ENTRY_ICON_NAME_PROPERTY:
		sharing_widgets_service_entry_set_icon_name (self, g_value_get_string (value));
		break;
		case SHARING_WIDGETS_SERVICE_ENTRY_SERVICE_STATE_PROPERTY:
		sharing_widgets_service_entry_set_service_state (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

